## libertine-scope 1.0-0ubuntu1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)
project(libertine-scope
        VERSION 1.0
        LANGUAGES CXX)

# We require at least g++ 4.9, to avoid ABI breakage with earlier versions.
set(cxx_version_required 4.9)
if (CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${cxx_version_required})
        message(FATAL_ERROR "g++ version must be at least ${cxx_version_required}!")
    endif()
endif()

# Set strict and naggy C++ compiler flags, and enable C++11
add_definitions(
  -fno-permissive
  -std=c++11
  -pedantic
  -Wall
  -Wextra
  -fPIC
  -DQT_NO_KEYWORDS
)

# Search for our dependencies
include(GNUInstallDirs)
find_package(PkgConfig)
find_package(Intltool)
find_package(Qt5Core REQUIRED)
find_package(Qt5Gui REQUIRED)

pkg_check_modules(SCOPE libunity-scopes>=0.6.0 REQUIRED)

# Add our dependencies to the include paths
include_directories(
  ${CMAKE_SOURCE_DIR}
  ${CMAKE_SOURCE_DIR}/libertine-scope
  ${SCOPE_INCLUDE_DIRS}
)

# Important project paths
set(SCOPE_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/unity-scopes/libertine-scope/)
set(SCOPE_NAME "libertine-scope")
set(GETTEXT_PACKAGE "${SCOPE_NAME}")
set(PACKAGE_NAME "libertine-scope.canonical")

# If we need to refer to the scope's name or package in code, these definitions will help
add_definitions(-DPACKAGE_NAME="${PACKAGE_NAME}")
add_definitions(-DSCOPE_NAME="${SCOPE_NAME}")
add_definitions(-DGETTEXT_PACKAGE="${GETTEXT_PACKAGE}")

# This command figures out the target architecture and puts it into the manifest file
execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH
                OUTPUT_VARIABLE CLICK_ARCH
                OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Configure and install the click manifest and apparmor files
configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
        DESTINATION ${SCOPE_INSTALL_DIR})
install(FILES "libertine-scope.apparmor"
        DESTINATION ${SCOPE_INSTALL_DIR})

# Add our main directories
add_subdirectory(libertine-scope)
add_subdirectory(data)
add_subdirectory(po)

# Set up the tests
enable_testing()
add_subdirectory(tests)
add_custom_target(check
                 ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure
)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
add_custom_target(dist
  COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== data/CMakeLists.txt ===

# Put the ini files in the build directory next to the scope
# .so file so that the test tools can find them.
intltool_merge_translations(
  "libertine-scope.ini.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${SCOPE_NAME}.ini"
  ALL
  UTF8
)
intltool_merge_translations(
  "libertine-scope-settings.ini.in"
  "${CMAKE_CURRENT_BINARY_DIR}/${SCOPE_NAME}-settings.ini"
  ALL
  UTF8
)

# Install the scope ini files
install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/${SCOPE_NAME}.ini"
    "${CMAKE_CURRENT_BINARY_DIR}/${SCOPE_NAME}-settings.ini"
  DESTINATION
    ${SCOPE_INSTALL_DIR}
)

# Put the logo file in the build directory next to the scope
# .ini file so that the test tools can find it.
configure_file(
  "logo.png"
  "${CMAKE_CURRENT_BINARY_DIR}/logo.png"
  @ONLY
  COPYONLY
)

# Install the scope images
install(
  FILES
    "icon.png"
    "logo.png"
  DESTINATION
    ${SCOPE_INSTALL_DIR}
)

=== libertine-scope/CMakeLists.txt ===
SET (CMAKE_AUTOMOC ON)

pkg_check_modules(URL_DISPATCHER REQUIRED url-dispatcher-1)

# Find all the sources
file(GLOB_RECURSE
  SCOPE_SOURCES
  "*.cpp"
  "*.h"
)

add_library(scope SHARED
  ${SCOPE_SOURCES}
)

include_directories(${URL_DISPATCHER_INCLUDE_DIRS})

target_link_libraries(scope
  ${SCOPE_LDFLAGS}
  Qt5::Core
  Qt5::Gui
  ${URL_DISPATCHER_LIBRARIES}
)


set_target_properties(scope
  PROPERTIES
    OUTPUT_NAME "${SCOPE_NAME}"
)

install(TARGETS scope
  LIBRARY DESTINATION ${SCOPE_INSTALL_DIR}
)

=== tests/CMakeLists.txt ===
# Build with system gmock and its embedded gtest -- the horror of hardcoding
set (GMOCK_SOURCE_DIR "/usr/src/gmock" CACHE PATH "gmock source directory")
set (GTEST_INCLUDE_DIR "${GMOCK_SOURCE_DIR}/gtest/include" CACHE PATH "gtest source include directory")
add_subdirectory(${GMOCK_SOURCE_DIR} "${CMAKE_CURRENT_BINARY_DIR}/gmock")

add_executable(libertine_scope_tests
  fake_container.cpp
  fake_libertine.cpp
  test_scope.cpp
)

target_link_libraries(libertine_scope_tests
  scope
  Qt5::Core
  gmock
  gmock_main
)

add_test(test_scope
  libertine_scope_tests
)

=== debian/changelog ===
libertine-scope (1.0-0ubuntu1) xenial; urgency=low

  * Initial release (lp: #1541417).

 -- Stephen M. Webb <stephen.webb@canonical.com>  Wed, 03 Feb 2016 19:42:14 -0500

=== debian/control ===
Source: libertine-scope
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Stephen M. Webb <stephen.webb@canonical.com>
Build-Depends: cmake (>= 3),
               cmake-extras,
               debhelper (>= 9),
               dh-translations,
               google-mock,
               intltool,
               libunity-scopes-dev (>= 0.6.0),
               liburl-dispatcher1-dev,
               pkg-config,
               qtbase5-dev
Standards-Version: 3.9.6
Homepage: https://launchpad.net/libertine-scope
Vcs-Bzr: https://code.launchpad.net/~libertine-team/libertine-scope/devel
Vcs-Browser: https://bazaar.launchpad.net/~libertine-team/libertine/devel/files

Package: libertine-scope
Architecture: any
Depends: libertine-tools,
         ${misc:Depends},
         ${shlibs:Depends}
Description: Libertine packages scope for Unity
 The Libertine package scope surfaces applications installed in a Libertine
 sandbox for the support of deb-packaged X11-based legacy software that is
 still waiting to be ported natively to Unity.
 .
 This package provides the Libertine scope itself.

=== debian/rules ===
#!/usr/bin/make -f 

%:
	dh $@ --with translations

=== debian/watch ===
version=3
opts="pgpsigurlmangle=s/$/.asc/" \
 http://launchpad.net/libertine-scope/+download .*/libertine-scope-([0-9.]+)\.tar\.bz2

## libertine-scope 1.3.2+16.10.20160812

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0.2)
cmake_policy(SET CMP0048 NEW)

project(libertine-scope
        VERSION 1.3.2
        LANGUAGES CXX)

# We require at least g++ 4.9, to avoid ABI breakage with earlier versions.
set(cxx_version_required 4.9)
if (CMAKE_COMPILER_IS_GNUCXX)
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS ${cxx_version_required})
        message(FATAL_ERROR "g++ version must be at least ${cxx_version_required}!")
    endif()
endif()

# Set strict and naggy C++ compiler flags, and enable C++11
add_definitions(
  -fno-permissive
  -std=c++11
  -pedantic
  -Wall
  -Wextra
  -fPIC
  -DQT_NO_KEYWORDS
)

# Search for our dependencies
include(GNUInstallDirs)
find_package(PkgConfig REQUIRED)
find_package(Intltool)
find_package(Qt5Core REQUIRED)
find_program(INTLTOOL_MERGE intltool-merge)

# useful variables
set(APPS_LIB_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/unity-scopes/libertine-scope/)
set(APPS_DATA_DIR ${CMAKE_INSTALL_FULL_DATADIR}/unity/scopes/libertine-scope/)
set(SCOPE_NAME "libertine-scope")
set(SCOPE_DISPLAY_NAME "Desktop Apps")
set(PACKAGE_NAME "libertine-scope.ubuntu")
set(FULLY_QUALIFIED_NAME "${PACKAGE_NAME}_${SCOPE_NAME}")
option(CLICK_MODE "Installs to a contained location" off)

add_definitions(-DSCOPE_NAME="${SCOPE_NAME}")
add_definitions(-DGETTEXT_PACKAGE="${SCOPE_NAME}")

pkg_check_modules(SCOPE libunity-scopes>=1.0.0 REQUIRED)
pkg_check_modules(UAL ubuntu-app-launch-2>=0.9.0 REQUIRED)
pkg_check_modules(LIBERTINE libertine>=0.99 REQUIRED)

# Add our dependencies to the include paths
include_directories(
  ${CMAKE_SOURCE_DIR}
  ${SCOPE_INCLUDE_DIRS}
  SYSTEM ${UAL_INCLUDE_DIRS}
  ${LIBERTINE_INCLUDE_DIRS}
)

set(APP ${PROJECT})

# Important project paths
if (CLICK_MODE)
  set(SCOPE_INSTALL_DIR "/libertine-scope")
else()
  set(SCOPE_INSTALL_DIR ${CMAKE_INSTALL_FULL_LIBDIR}/unity-scopes/libertine-scope/)
endif(CLICK_MODE)

set(SCOPE_NAME "libertine-scope")
set(GETTEXT_PACKAGE "${SCOPE_NAME}")

# This command figures out the target architecture and puts it into the manifest file
execute_process(COMMAND dpkg-architecture -qDEB_HOST_ARCH
                OUTPUT_VARIABLE CLICK_ARCH
                OUTPUT_STRIP_TRAILING_WHITESPACE
)

# Configure and install the click manifest and apparmor files
configure_file(manifest.json.in ${CMAKE_CURRENT_BINARY_DIR}/manifest.json)
if (CLICK_MODE)
  install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
        "libertine-scope.apparmor"
        DESTINATION "/")
else()
  install(FILES
        ${CMAKE_CURRENT_BINARY_DIR}/manifest.json
        "libertine-scope.apparmor"
        DESTINATION ${SCOPE_INSTALL_DIR})
endif()

# Add our main directories
add_subdirectory(scope)
add_subdirectory(data)
add_subdirectory(po)

# Set up the tests
enable_testing()
add_subdirectory(tests)
add_custom_target(check ${CMAKE_CTEST_COMMAND} --force-new-ctest-process --output-on-failure)

set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
add_custom_target(dist
  COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

=== apps/CMakeLists.txt ===
set (CMAKE_INCLUDE_CURRENT_DIR ON)
set (CMAKE_AUTOMOC ON)

pkg_check_modules(URL_DISPATCHER REQUIRED url-dispatcher-1)

# Find all the sources
file(GLOB_RECURSE SCOPE_SOURCES
  "*.cpp"
  "*.h"
)

add_library(apps SHARED
  ${SCOPE_SOURCES}
)

include_directories(${URL_DISPATCHER_INCLUDE_DIRS})

target_link_libraries(apps
  ${SCOPE_LDFLAGS}
  ${UAL_LDFLAGS}
  ${LIBERTINE_LDFLAGS}
  Qt5::Core
  ${URL_DISPATCHER_LIBRARIES}
)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h"
)

set_target_properties(apps
  PROPERTIES
    OUTPUT_NAME ${FULLY_QUALIFIED_NAME}
)

install(TARGETS apps
  LIBRARY DESTINATION "${APPS_LIB_DIR}"
)

set(APPS_INI_TARGET ${FULLY_QUALIFIED_NAME}.ini)
configure_file(
  ${APPS_INI_TARGET}.in.in
  ${APPS_INI_TARGET}.in
)

add_custom_target(${APPS_INI_TARGET} ALL
  COMMENT "Merging translations into ${APPS_INI_TARGET}"
  COMMAND LC_ALL=C ${INTLTOOL_MERGE} -d -u ${CMAKE_SOURCE_DIR}/po ${APPS_INI_TARGET}.in ${APPS_INI_TARGET} >/dev/null
)

install(
  FILES "${CMAKE_CURRENT_BINARY_DIR}/${APPS_INI_TARGET}"
  DESTINATION "${APPS_LIB_DIR}"
)

## libertine-scope 1.3.2+17.04.20170228

=== CMakeLists.txt ===
--- 
+++ 
@@ -44,7 +44,7 @@
 add_definitions(-DGETTEXT_PACKAGE="${SCOPE_NAME}")
 
 pkg_check_modules(SCOPE libunity-scopes>=1.0.0 REQUIRED)
-pkg_check_modules(UAL ubuntu-app-launch-2>=0.9.0 REQUIRED)
+pkg_check_modules(UAL ubuntu-app-launch-3>=0.9.0 REQUIRED)
 pkg_check_modules(LIBERTINE libertine>=0.99 REQUIRED)
 
 # Add our dependencies to the include paths
